package testclasses;


/* * H3CMainFileMenu.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/08/17, 5:59
 * up 2003/11/12
 * up 2004/12/17
 * up 2005/02/11
 * up 2005/05/16
 * up 2005/09/15
 * up 2005/11/27
 * up 2005/12/04
 */


import org.hichart.h3code.Table;
import org.hichart.h3code.tool.H3CCodeGenerator;
import org.hichart.h3code.tool.H3CContentParser;
import org.hichart.h3code.tool.H3CFileSaver;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;


public class H3CMainFileMenu extends JMenu implements ActionListener{
    
    /**
	 * serialVersionUID: Automatic generated ID
	 */
	private static final long serialVersionUID = -6426348430942772666L;

	//private static H3CMainFrame frame;
	private H3CodeViewer frame;
    
    private static final String title = "File";
    private static final String open_label = "Open";
    private static final String save_label = "Save"; //041217
    private static final String exit_label = "Exit";
    
    /* 050307 */
	//private static final String new_table_label = "New Table";
	//private static JMenuItem new_table = new JMenuItem(new_table_label);
	
    private static JMenuItem open = new JMenuItem(open_label);
    private static JMenuItem save = new JMenuItem(save_label); //041217
    private static JMenuItem exit = new JMenuItem(exit_label);
    
    private static File open_file = null;
    private static File save_file = null; //041217
    private static File current_dir = null; 
    
    
    /** RXgN^ */
    public H3CMainFileMenu(H3CodeViewer frame){
        super(title);
        this.frame = frame;
        initMenuItems();
    }
    
    
    /** j[̏ */
    private void initMenuItems(){
        
    	/* Openj[iH3-CodeJj */
        open.addActionListener(this);
        add(open);
        
        //new 2004/12/17
        /* Savej[iH3-Codeۑj */
        save.addActionListener(this);
        add(save);
        
        //Zp[^
        addSeparator();
        
        //new
        /* Exportj[iH3-Code(`,\)SVGŕۑj */
        //add(new ext.jcomp.ExportSVGJMenuItem(frame.getH3CTableViewPanel(), frame));
        
        //new 2003/11/12
        /* Exportj[iH3-Code(Ot)SVGŕۑj */
        //add(new ext.jcomp.ExportSVGforListJMenuItem(frame.getH3CListViewPanel(), frame));
        
        
        //Zp[^
        addSeparator();
        
        /* I */
        exit.addActionListener(this);
        add(exit);
    }
    
    
    /* Cxg */
    public void actionPerformed(ActionEvent e){
        if(e.getSource() instanceof JMenuItem){
            JMenuItem menu = (JMenuItem)e.getSource();
            String menu_label = menu.getText();
            
            if(menu_label.equals(open_label)){
                occurOpenEvent();
            }else if(menu_label.equals(save_label)){//0412017
            	occurSaveEvent();
            }else if(menu_label.equals(exit_label)){
                occurExitEvent();
            }
        }
    }
    
    
    /** OpenIƂ̏ */
    public void occurOpenEvent(){
        openWindow();
        try{
            frame.setTable(loadTable());
        }catch(Exception e){
        }
    }
    
    //041217
    /** SaveIƂ̏ */
    private void occurSaveEvent(){
        saveWindow();
    }
    
    /** I */
    public void occurExitEvent(){
        System.exit(0);
    }
    
    
    /** t@COpenƂ̃t@C_CAO */
    public void openWindow(){
    	org.hichart.h3code.tool.H3CFileLoader loader = new org.hichart.h3code.tool.H3CFileLoader(frame);
        
        if(current_dir == null){
            loader.showHTCFileChooser();
        }else{
            loader.showHTCFileChooser(current_dir);
        }
        
        open_file = loader.getFile();
        current_dir = loader.getDir();
    }
    
    
    /* ݂̃t@Ce[u쐬 */
    public org.hichart.h3code.Table loadTable(){
        try{
            BufferedReader br = new BufferedReader(new FileReader(open_file));
            org.hichart.h3code.tool.H3CParser parser = new org.hichart.h3code.tool.H3CParser();
        
            org.hichart.h3code.Table table = new org.hichart.h3code.Table();
            parser.analyze(br, table);
            parser.initWallValuesOfCells(table); /* 2005/02/11 */
            
            
            //2005/12/04 Contents
            String cpath = open_file.getPath() + ".hcc";
            System.out.println("Content:"+cpath);
            
            try{ 
            	File cfile = new File(cpath);
            	BufferedReader cbr = new BufferedReader(new FileReader(cfile));
            	H3CContentParser cparser = new H3CContentParser();
            	cparser.analyze(cbr, table);
            }catch(Exception e){}
            //2005/12/04 Contents
            
            System.out.println("Analysis was completed.");//debug
            if(table != null){ System.out.println("Table was constructed."); }//debug
            
            br.close();
            return table;
        }catch(Exception e){}
        return null;
    }
    
    
    //0412017
    /** Save_CAOp̏ */
    private void saveWindow(){
    	H3CFileSaver saver = new H3CFileSaver(frame);
    	
    	if(current_dir == null){ saver.showHTCFileChooser(null); }
        else{ saver.showHTCFileChooser(current_dir); }
    	
    	save_file   = saver.getFile();
        current_dir = saver.getDir();
        
        saveTable(frame.getTable());
    }
    
    private void saveTable(Table table){
    	if(table == null){ return; }
    	
    	
    	try{
    		java.io.PrintWriter pw = new java.io.PrintWriter(new java.io.FileOutputStream(save_file));
    		H3CCodeGenerator generator = new H3CCodeGenerator(table, pw);
    		generator.generate();
    		pw.close();
        }catch(Exception e){}
    	
    }

}
