/*
 * Table.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/08/15, 4:39
 * BugFix on 2005/12/04
 */

package org.hichart.h3code;

import java.util.ArrayList;

/**
 * @author Tomokazu ARITA (arita@obirin.ac.jp)
 * @version 0.2.0 
 */
public class Table {
    
    /**
     * <code>HEAD</code> is a reserved number for the Top-Left perimeter cell. 
     */
    public static final int HEAD = 1; //lύXs
    
    
    /**
     * <code>TAIL</code> is a reserved number for the Bottom-Right perimeter cell. 
     */
    public static final int TAIL = 4; //lύXs
    
    /**
     * <code>cellSet</code> is the set of cells. 
     */
    private ArrayList cellSet = null;
    
    /**
     * <code>contentSet</code> is the set of contents. 
     * do not use
     */
    //private ArrayList contentSet = null;
    
    
    /** Creates a new instance of Table */
    public Table() {
        cellSet = new ArrayList();
        //contentSet = new ArrayList();
    }
    
    /* Constructer 2 */
    /** Creates a new instance of Table */
//    public Table(ArrayList cellSet, ArrayList contentSet) {
//        this.cellSet = cellSet;
//        this.contentSet = contentSet;
//    }
    
    /* Constructer 2 */
    /** Creates a new instance of Table */
    public Table(ArrayList cellSet) {
    	this.cellSet = cellSet;
    }
    
    /*  */
    //public Table(int Row, int Column){}
    
    
    /**
     * Sets a set of cells that constract a table. 
     * @param cells  an instance of ArrayList.class that follows rules and conditions of H3-Code. 
     */
    public void setCellSet(ArrayList cells){
        this.cellSet = cells;
    }
    
    
    /**
     * Gets the set of cells in this instance. 
     * @return the set of cells 
     */
    public ArrayList getCellSet(){
        return cellSet;
    }
    
    /**
     * Sets a set of contens. 
     * @param contents  contents in this table. 
     */
//    public void setContentSet(ArrayList contents){
//        this.contentSet = contents;
//    }
    
    /**
     * Gets the set of contents in this table.
     * @return the set of contents. 
     */
//    public ArrayList getContentSet(){
//        return contentSet;
//    }
    
    /* Cell̒ǉiύXj */
    /**
     * Adds a cell. 
     * @param index  the ID of <code>cell</code>
     * @param cell   an added cell
     */
    public void addCell(int index, AbstractCell cell){
        System.out.println("No."+index+" cell is added.");//debug
        cellSet.add(index, cell);
    }
    
    /* Content̒ǉiύXj */
    /**
     * Adds a content. 
     * @param index    the ID of a cell to add <code>content</code>.
     * @param content  a content. 
     */
//    public void addContent(int index, Content content){
//        contentSet.add(index, content);
//    }
    
    /* Cell̒uiύXj */
    /**
     * Sets a cell with ID. 
     * @param index  the ID number of <code>cell</code>
     * @param cell   a setted cell.
     */
    public void setCell(int index, AbstractCell cell){
        cellSet.set(index, cell);
    }
    
    /* Content̒uiύXj */
    /**
     * Sets a content with ID. 
     * @param index    the ID number of cell setted this <code>content</code>
     * @param content  a setted content
     */
//    public void setContent(int index, Content content){
//        contentSet.set(index, content);
//    }
    
    /* content_id (=index) ̃RecԂ */
    /* contentSet̗vfȂꍇnullԂ */
    /**
     * Gets a content. 
     * @param content_id  the ID number of a content. 
     * @return the content with <code>content_id</code>
     */
//    public Content getContent(int content_id){
//        //if(contentSet.isEmpty()){ return null;}
//        return (Content)contentSet.get(content_id);
//    }
    
    /* SZ̍폜iRecɉeȂj */
    /**
     * Clears the set of cells in this table. 
     */
    public void clearCellSet(){
        cellSet.clear();
    }
    
    /* SRec̍폜 (ZɕύXȂ) */
    /**
     * Clears the set of contents in this table. 
     */
//    public void clearContentSet(){
//        contentSet.clear();
//    }
    
    /*  */
    /* e[ũZ̃Nf */
    /* Ȃ΍č\D*/
    /* č\łȂfalseԂ */
   //public boolean normalize(){}
   
    
   /*  */
   /* Z̎̐ڑׂ */
   //private boolean checkLinks(h3code.AbstractCell cell){}
    
    /* Ԃ */
    /**
     * Gets the width of this table. 
     * @return  the width
     */
    public int getWidth(){
        if(cellSet != null && cellSet.isEmpty() != true){
            AbstractCell cell = (AbstractCell) getTail();
            cell = (AbstractCell)cellSet.get(cell.getConnectedCell(AbstractLinkedNode.WWE_UPPER));
            cell = (AbstractCell)cellSet.get(cell.getConnectedCell(AbstractLinkedNode.SWE_LEFT));
            return cell.getWall(AbstractCell.EAST);
        }
        return 0;
    }
    
    /* Ԃ */
    /**
     * Gets the height of this table. 
     * @return the height
     */
    public int getHeight(){
        if(cellSet != null && cellSet.isEmpty() != true){
            AbstractCell cell = (AbstractCell) getTail();
            cell = (AbstractCell)cellSet.get(cell.getConnectedCell(AbstractLinkedNode.WWE_UPPER));
            cell = (AbstractCell)cellSet.get(cell.getConnectedCell(AbstractLinkedNode.SWE_LEFT));
            return cell.getWall(AbstractCell.SOUTH);
        }
        return 0;
    }
    
    /* XWԂ */
    /* 0ł */
    /**
     * Gets the x-coordinate of this table. 
     * @return 0 (always)
     */
    public int getX(){ return 0; }
    
    
    /* YWԂ */
    /* 0ł */
    /**
     * Gets the y-coordinate of this table.
     * @return 0 (always)
     */
    public int getY(){ return 0; }
    
    /* e[ũwbhԂ */
    /**
     * Gets the head cell of this table. 
     * @return the head cell (id=1)
     */
    public AbstractCell getHead(){
        if(cellSet != null && cellSet.isEmpty() != true){
            return (AbstractCell)cellSet.get(HEAD);
        }
        return null;
    }
    
     /* e[ȕI[ZԂ */
    /**
     * Gets the tail cell of this table. 
     * @return the tail cell (id=4)
     */
    public AbstractCell getTail(){
        if(cellSet != null && cellSet.isEmpty() != true){
            return (AbstractCell)cellSet.get(TAIL);
        }
        return null;
    }
}
